#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import numpy as np

from redcp import * # import data types

DELTA_DISTANCE = 0.12
C_TURNING_SPEED = 5
C_AVOID_SPEED = 10

class Controller:
    def __init__(self):
        pass

    def goto(self, goal: Pose, odometry: Pose, collision: bool) -> Twist:
        """Method to steer the robot towards the goal position given its current 
           odometry and collision status
        Args:
            goal: Pose of the robot goal
            odometry: Perceived odometry of the robot
            collision: bool of the robot collision status
        Returns:
            cmd: Twist steering command
        """
        # zero velocity steering command
        if odometry is None or goal is None: return Twist()
        if collision: return None

        cmd_msg = Twist()
        
        return cmd_msg            

    def goto_reactive(self, goal: Pose, odometry: Odometry, collision: bool, laser_scan: LaserScan) -> Twist:
        """Method to steer the robot towards the goal position while avoiding 
           contact with the obstacles given its current odometry, collision 
           status and laser scan data
        Args:
            goal: Pose of the robot goal
            odometry: Perceived odometry of the robot
            collision: bool of the robot collision status
            laser_scan: LaserScan data perceived by the robot
        Returns:
            cmd: Twist steering command
        """

        #TODO: if input data are valid, calculate the steering command
        cmd_msg = Twist()

        return cmd_msg
