import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt

def draw_goal_locations(gridmap, locations, locations_ref, title):
    fig, ax = plt.subplots() #plot the map
    gridmap.plot(ax) #plot the gridmap
    # ans = input().split(' ')[0] getchar

    for p in locations_ref:
        h1, = ax.plot([p.position.x],[p.position.y],'+', markersize=20, linewidth=2)
    for location in locations:
        h2, = ax.plot([location.position.x], [location.position.y], 'o', markerfacecolor='none', markersize=20, linewidth=2)
    ax.set_xlabel('x[m]')
    ax.set_ylabel('y[m]')
    if len(locations):
        ax.legend([h1, h2], ['Reference', 'Solution'], markerscale=0.5)
    else:
        ax.legend([h1], ['Reference'], markerscale=0.5)
    ax.set_aspect('equal', 'box')
    ax.set_title(title)
    return fig

def save_image(fig, msg, image_file):
    fig.savefig(image_file, bbox_inches='tight')
    print(msg, image_file) 
    return

