#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import numpy as np
import numbers 

class Point2D:
    """
    Basic class for representing 2D x,y point
    Data entries:
    float64 x
    float64 y
    """
    __attributes__ = ['x', 'y']
    __attribute_types = ['float64', 'float64']
    
    def __init__(self, x, y):
        if x == None:
            self.x = 0.0
        else:
            self.x = x
        if y == None:
            self.y = 0.0
        else:
            self.y = y

    def __add__(self, other):
        v = Point2D(self.x + other.x,
                    self.y + other.y)
        return v
    
    def __IADD__(self, other):
        self.x += other.x
        self.y += other.y

    def __sub__(self, other):
        v = Point2D(self.x - other.x,
                    self.y - other.y)
        return v
    
    def __ISUB__(self, other):
        self.x -= other.x
        self.y -= other.y

    def __mul__(self, other):
        if isinstance(other, numbers.Number):
            v = Point2D()
            v.x = self.x * other
            v.y = self.y * other
            return v
        else:
            return None
    
    def __IMUL__(self, other):
        if isinstance(other, numbers.Number):
            self.x *= other
            self.y *= other

    def norm(self):
        return np.linalg.norm(np.asarray([self.x, self.y, self.z]))


#Examples of usage
if __name__=="__main__":
    x = Point2D()
    print(x.x, x.y)

    y = Vector3(1, 2)
    print(x.x, x.y)

    print(x + y)
