#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import os

import SOMSolver as som
from utils import *

RESULT_DIR = 'results'

dataset = [
    ("berlin52", 0.5), # problem name disk radius

    #("burma14", 0.0),
    #("burma14", 0.5),
    #("burma14", 1.0),

    #("att48", 0.0),
    #("att48", 200.0),
    #("att48", 500.0),
]

animate = True

if __name__=="__main__":
    if not os.path.exists(RESULT_DIR): os.mkdir(RESULT_DIR)
    planner = som.SOMSolver()
    for problem, radius in dataset:
        goals = load_problem('./problems/' + problem + '.txt') # load problem from a file

        print("Solving {}, radius = {} ----------- ".format(problem, radius))
        path = planner.plan_tour(goals, radius, animate)

        fig = draw_tspn_solution(goals, radius, path, 'Solution ' + problem + ' radius ' + str(radius))
        image_file = RESULT_DIR + '/' + problem + '-r' + str(radius) + '.png'
        save_image(fig, 'Save solution ' + problem + ' radius ' + str(radius).replace('.', '') + ' to ' + image_file, image_file)
        
